diff --git a/firmware/global.h b/firmware/global.h
index bb3fe0e26d7..556ba1c7967 100644
--- a/firmware/global.h
+++ b/firmware/global.h
@@ -15,6 +15,13 @@
 #ifndef GLOBAL_H_
 #define GLOBAL_H_
 
+// todo: move this magic to somewhere shared between firmware and simulator?
+#ifdef __cplusplus
+#define EXTERNC extern "C"
+#else
+#define EXTERNC
+#endif
+
 #ifdef __cplusplus
 extern "C"
 {
diff --git a/firmware/hw_layer/drivers/gpio/tle8888.c b/firmware/hw_layer/drivers/gpio/tle8888.c
index 16e8b8da342..797fccdd133 100644
--- a/firmware/hw_layer/drivers/gpio/tle8888.c
+++ b/firmware/hw_layer/drivers/gpio/tle8888.c
@@ -16,6 +16,9 @@
 /* to be removed */
 #include "engine_configuration.h"
 
+EXTERN_CONFIG;
+
+#include "hardware.h"
 #include "gpio/gpio_ext.h"
 #include "gpio/tle8888.h"
 #include "pin_repository.h"
@@ -257,7 +260,7 @@ int tle8888_add(unsigned int index, const struct tle8888_config *cfg)
 /*********TO BE REMOVED FROM THIS FILE***************/
 
 /* this should be in board file */
-static const struct tle8888_config tle8888_cfg = {
+static struct tle8888_config tle8888_cfg = {
 	.spi_bus = NULL/*&SPID4*/,
 	.spi_config = {
 		.circular = false,
@@ -288,6 +291,8 @@ static const struct tle8888_config tle8888_cfg = {
 
 void initTle8888(DECLARE_ENGINE_PARAMETER_SIGNATURE)
 {
+	tle8888_cfg.spi_bus = getSpiDevice(engineConfiguration->tle8888spiDevice);
+
 	tle8888_add(0, &tle8888_cfg);
 }
 
diff --git a/firmware/hw_layer/hardware.h b/firmware/hw_layer/hardware.h
index e0224937017..4db661fb3e1 100644
--- a/firmware/hw_layer/hardware.h
+++ b/firmware/hw_layer/hardware.h
@@ -33,7 +33,7 @@
 
 int getSpiPrescaler(spi_speed_e speed, spi_device_e device);
 
-SPIDriver * getSpiDevice(spi_device_e spiDevice);
+EXTERNC SPIDriver * getSpiDevice(spi_device_e spiDevice);
 void turnOnSpi(spi_device_e device);
 void lockSpi(spi_device_e device);
 void unlockSpi(void);
diff --git a/firmware/hw_layer/pin_repository.h b/firmware/hw_layer/pin_repository.h
index f158b783b98..31081d06d0b 100644
--- a/firmware/hw_layer/pin_repository.h
+++ b/firmware/hw_layer/pin_repository.h
@@ -27,12 +27,6 @@ class PinRepository {
 
 #define PORT_SIZE 16
 
-#ifdef __cplusplus
-#define EXTERNC extern "C"
-#else
-#define EXTERNC
-#endif
-
 void initPinRepository(void);
 EXTERNC bool brain_pin_is_onchip(brain_pin_e brainPin);
 EXTERNC bool markUsed(ioportid_t port, ioportmask_t pin, const char *msg);
@@ -42,6 +36,4 @@ EXTERNC void brain_pin_markUnused(brain_pin_e brainPin);
 const char * getPinFunction(brain_input_pin_e brainPin);
 void unmarkPin(brain_pin_e brainPin);
 
-#undef EXTERNC
-
 #endif /* PIN_REPOSITORY_H_ */
diff --git a/simulator/simulator/global.h b/simulator/simulator/global.h
index ca6f12ef9fe..1d6555a8a68 100644
--- a/simulator/simulator/global.h
+++ b/simulator/simulator/global.h
@@ -10,6 +10,13 @@
 #ifndef GLOBAL_H_
 #define GLOBAL_H_
 
+// todo: move this magic to somewhere shared between firmware and simulator?
+#ifdef __cplusplus
+#define EXTERNC extern "C"
+#else
+#define EXTERNC
+#endif
+
 #include <ch.h>
 #include <hal.h>
 
